package com.github.oxal;

import org.graphstream.graph.Graph;
import org.graphstream.graph.implementations.DefaultGraph;
import org.graphstream.graph.implementations.SingleGraph;
import org.graphstream.stream.file.FileSource;
import org.graphstream.stream.file.FileSourceEdge;
import org.graphstream.stream.file.FileSourceFactory;

import java.io.IOException;
import java.util.stream.Collector;
import java.util.stream.Collectors;

public class Main {

    public static void main(String[] args) {
        String filePath = "src/main/resources/graph.txt";
        Graph g = new DefaultGraph("g");
        FileSource fs = new FileSourceEdge();

        fs.addSink(g);

        try {
            fs.readAll(filePath);
        } catch (IOException e) {
            e.printStackTrace();
        }

        //nb de node
        System.out.println(g.getNodeSet().stream().count());

        //nb de edge
        System.out.println(g.getEdgeSet().stream().count());


        //moyenne de degré
        System.out.println(g.getNodeSet()
                .stream()
                .mapToDouble(n -> n.getDegree())
                .average()
                .getAsDouble()
        );


    }
}
